uses crt;

type TMouseInfo=record
            		activeFlag:integer;
					x,y,dx,dy:integer;
    				mouseButtonsState:integer;
				    dataSegment:integer;
				end;
var
    mouseInfo:TMouseInfo;


function int2str(int:integer):string;
var sint:string;
begin
	str(int, sint);
    int2str:=sint;
end;

procedure asmInitMouse;assembler;
asm
    mov AX,0000H
    int 33H
end;

procedure asmShowCursor;assembler;
asm
	mov AX,0001H
    int 33H
end;

procedure asmHideCursor;assembler;
asm
	mov AX,0002H
    int 33H
end;


procedure asmGetMouseClickInfo(var x,y,clickCount:integer);assembler;
asm
	mov AX,0005H
    mov BX,0000H
    int 33H

    mov AX,BX
    les	DI,clickCount
    stosw

    mov AX,CX
	les	DI,x
    stosw

    mov AX,DX
	les	DI,y
    stosw
end;

procedure asmGetMouseReleaseInfo(var x,y,clickCount:integer);assembler;
asm
	mov AX,0006H
    mov BX,0000H
    int 33H

    mov AX,BX
    les	DI,clickCount
    stosw

    mov AX,CX
	les	DI,x
    stosw

    mov AX,DX
	les	DI,y
    stosw
end;

procedure asmGetTypeMouse(var driverVersionLow,driverVersionHigh,mouseType,usedIRQ:integer);assembler;
asm

	mov AX,0024H
    int 33H

    xor AH,AH

    mov AL,BL
	les	DI,driverVersionLow
    stosw

    mov AL,BH
	les	DI,driverVersionHigh
    stosw

    mov AL,CH
	les	DI,mouseType
    stosw

    mov AL,CL
	les	DI,usedIRQ
    stosw
end;

{procedure asmMouseEventDriver;assembler;
asm
   	mov mouseInfo.activeFlag,1
    mov mouseInfo.mouseButtonsState,BX
    mov mouseInfo.x,CX
    mov mouseInfo.y,DX
    mov mouseInfo.dataSegment,DS
end;


procedure asmSetMouseEventDriver(mask:integer;driver:pointer);assembler;
asm
    mov	AX,0CH
    mov CX,mask
    mov DX,offset driver
    int 33H
end;}

procedure asmSetCursor(code:byte);assembler;
asm
	mov AX,000aH
    mov BX,0000H
    mov CX,7000H
    mov DL,code
    mov DH,07H
    int 33H
end;


procedure getMouseClickInfo(var x,y,clickCount:integer);
begin
    asmGetMouseClickInfo(x,y,clickCount);
end;

procedure getMouseReleaseInfo(var x,y,clickCount:integer);
begin
    asmGetMouseReleaseInfo(x,y,clickCount);
end;

procedure _drawWindow(x1,y1,x2,y2,bgcolor,txtcolor:integer);
begin
	window(x1,y1,x2,y2);
    textBackGround(bgcolor);
    textColor(txtcolor);
    clrscr;
end;

procedure _drawAllWindows;
begin
    textBackGround(black);
    clrscr;
end;

procedure putChar(ch:char;x,y:integer);
begin
 	gotoxy(x,y);
    write(ch);
end;

const Esc=#27;
var ch:char;
	x,y,clickCount:integer;
    driverVersionLow,driverVersionHigh,mouseType,usedIRQ:integer;

begin
    _drawAllWindows;
    asmInitMouse;
    asmShowCursor;
    ch:='A';
    asmSetCursor(ord(ch));
    {asmSetMouseEventDriver(2,@asmMouseEventDriver);}
    asmGetTypeMouse(driverVersionLow,driverVersionHigh,mouseType,usedIRQ);

    write(driverVersionLow);
    write(' - ');
    write(driverVersionHigh);
    write(' - ');
    write(mouseType);
    write(' - ');
    writeln(usedIRQ);
    repeat
        repeat
			getMouseClickInfo(x,y,clickCount);
            if clickCount>0 then
            	begin
                	asmHideCursor;
					putChar(ch, (x div 8)+1, (y div 8)+1);
                	ch:=chr(ord(ch)+1);
                    asmSetCursor(ord(ch));
                    asmShowCursor;
                    repeat
                    	getMouseReleaseInfo(x,y,clickCount);
                    until clickCount>0;
                end;
			{if (mouseInfo.activeFlag=1) and (odd(mouseInfo.mouseButtonsState)) then
            	begin
                	mouseInfo.activeFlag:=0;
                	putChar(codeChar);
                	inc(codeChar);
                    asmSetCursor(codeChar);
                end;}

        until keyPressed;
		ch:=readkey;
    until ch=Esc;
    {asmSetMouseEventDriver(0,@asmMouseEventDriver);}
    asmHideCursor;
end.